
require "./AI/USER_AI/Const.lua"
require "./AI/USER_AI/Callback.lua"
require "./AI/USER_AI/Extra.lua"
require "./AI/USER_AI/Setting.lua"
require "./AI/USER_AI/Util.lua"

-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST				= 1
CHASE_ST				= 2
ATTACK_ST				= 3
MOVE_CMD_ST				= 4
STOP_CMD_ST				= 5
ATTACK_OBJECT_CMD_ST			= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8
HOLD_CMD_ST				= 9
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST			= 11
FOLLOW_CMD_ST				= 12
STANDBY_ST				= 13
----------------------------

--------------------------
-- motion
--------------------------

MOTION_STAND   =  0 -- ΩäƤ⡼ư
MOTION_MOVE    =  1 -- ưΥ⡼
MOTION_ATTACK  =  2 -- Υ⡼
MOTION_DEAD    =  3 -- ݤ⡼
MOTION_DAMAGE  =  4 -- ᡼Υ⡼
MOTION_PICKUP  =  5 -- ⡼
MOTION_SIT     =  6 -- ¤⡼
MOTION_SKILL   =  7 -- 빶⡼ʥ١ȥܥ塼󡢥饦ɥܥǧ
MOTION_CASTING =  8 -- Ӿ⡼
MOTION_ATTACK2 =  9 -- ⡼
MOTION_PP      = 12 -- ݡԥå㡼Υ⡼
MOTION_SLIMPP  = 28 -- ݡԥå㡼Υ⡼
--------------------------

------------------------------------------
-- global variable
------------------------------------------
MyState				= STANDBY_ST	-- ǽξ֤ϵ©
MyEnemy				= 0		-- ۥबåȤƤŨΥ饯ID
MyDestX				= 0		-- ۥɸɸXʰư / Ѻɸ
MyDestY				= 0		-- ۥɸɸYʰư / Ѻɸ
MyPatrolX			= 0		-- ۥबѥȥʱưˤɸX
MyPatrolY			= 0		-- ۥबѥȥʱưˤɸY
ResCmdList			= List.new()	-- ͽ̿ꥹ
MyID				= 0		-- ۥ󥯥륹 id
MySkill				= 0		-- ۥ󥯥륹Υ
MySkillLevel			= 0		-- ۥ󥯥륹Υ٥

MySkipEnemy				= 0	 -- Ũ id
Ludin_AttackCount = 0       -- <== ɲäƤ
Lidin_nDAL        = 0       -- <== ɲäƤ
Ludin_DontAttackList = { }  -- <== ɲäƤ

--By Privatemoon
MyOwner = GetV(V_OWNER,MyID)
TARGETDISTANCE 			= 8				-- 򤹤ŨΥߤεΥ 314٤ʤưϤŪˤϤ2ޥϰ
----ޤ

------------------------------------------

-- ưꥹ
AutoSkillCmdList		= List.new()

------------- command process  ---------------------

-------------------------------------------------------
-- MoveToOwnerˤĤ
-------------------------------------------------------

function	MoveToOwner (id)
	local x,y = GetV(V_POSITION,MyOwner)
	if (GetDistanceFromOwner(MyID) > 3) then
		Move (MyID,x,y)
	else
		local mx,my = GetV(V_POSITION,MyID)
		if (x < mx) then
			x = x + 1	
		elseif (x > mx) then
			x = x - 1
		end
		if (y < my) then
			y = y + 1
		elseif (y > my) then
			y = y - 1
		end
		Move (MyID,x,y)							-- ʬΤۥबɽ
	end
end

-------------------------------------------------------
-- ưޥɤ˴ؤ
-------------------------------------------------------
function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		return
	end

	local curX, curY = GetV (V_POSITION,MyID)
	if (math.abs(x-curX)+math.abs(y-curY) > 15) then		-- ŪϤΥʾʤ (СǱΥϽʤ)
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})			-- ŪϤؤΰưͽ󤹤.
		x = math.floor((x+curX)/2)							-- ˰ư.
		y = math.floor((y+curY)/2)							-- 
	end

	Move (MyID,x,y)		
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0

	ResetStopSearchEnemy()
	MoveCommand_Check(MyID,MyDestX, MyDestY)
	Friend_Check()
end

function	OnMOVE_AND_HOLD_CMD (x,y)

	TraceAI ("OnMOVE_AND_HOLD_CMD")

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == GetV(V_MOTION,MyID)) then
		OnHOLD_CMD ()
		return
	end
	Move (MyID,x,y)		
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0
end

-------------------------------------------------------
-- ߥޥɤ˴ؤ
-------------------------------------------------------
function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")

	if (GetV(V_MOTION,MyID) ~= MOTION_STAND) then
		Move (MyID,GetV(V_POSITION,MyID))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MySkill = 0

end


-------------------------------------------------------
-- ̾ﹶ⥳ޥɤ˴ؤ
-------------------------------------------------------
function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")

	MySkill = 0
	MyEnemy = id
	MyState = CHASE_ST

end

-------------------------------------------------------
-- ̻깶⥳ޥɤ˴ؤ
-------------------------------------------------------
function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")

	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= GetV(V_MOTION,MyID)) then
		Move (MyID,x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	
end

-------------------------------------------------------
-- ѥȥ륳ޥɤ˴ؤ
-------------------------------------------------------
function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")

	MyPatrolX , MyPatrolY = GetV (V_POSITION,MyID)
	MyDestX = x
	MyDestY = y
	Move (MyID,x,y)
	MyState = PATROL_CMD_ST

end


-------------------------------------------------------
-- ۡɥޥɤ˴ؤ
-------------------------------------------------------
function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")

	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MyState = HOLD_CMD_ST

end


-------------------------------------------------------
-- оݻꥹ륳ޥɤ˴ؤ
-------------------------------------------------------
function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI (string.format("OnSKILL_OBJECT_CMD : %d %d",skill, level))

	MySkillLevel = level
	MySkill = skill
	MyEnemy = id
	MyState = CHASE_ST

end

-------------------------------------------------------
-- ϰϥ륳ޥɤ˴ؤ
-------------------------------------------------------
function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI (string.format("OnSKILL_OBJECT_CMD : %d %d",skill, level))

	Move (MyID,x,y)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end


-------------------------------------------------------
-- ɽޥɤ˴ؤ
-------------------------------------------------------
function	OnFOLLOW_CMD ()

	TraceAI ("OnFOLLOW_CMD")

	MoveToOwner (MyID)
	MyState = FOLLOW_CMD_ST
	
	MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID))
	MyEnemy = 0 
	MySkill = 0

	StartMoveCommand();
end


-------------------------------------------------------
-- ޥɤդȤν
-------------------------------------------------------
function	ProcessCommand (msg)

	if		(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end




-------------- state process  --------------------
--Χ֤Ǥγƹư˴ؤ
--------------------------------------------------

-------------------------------------------------------
-- ɥ˴ؤ
-------------------------------------------------------
function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	-- ͽ󥳥ޥɽ
		return 
	end

	local	object = GetOwnerEnemy (MyID)
	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return 
	end

	object = GetFriendEnemy (MyID)
	if (object ~= 0) then							-- FRIEND_ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : FRIEND_ATTACKED_IN")
		return 
	end

	object = GetMyEnemy (MyID)
	if (object ~= 0) then							-- ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	if ( GetV(V_MOTION,MyOwner) == MOTION_SIT) then		-- ͤ¤äƤȤϾԵ(IDLE_ST)ˤ by ͺ
		MyState = IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLE_ST (OnlySit)")
		return;
	end

	local distance = GetDistanceFromOwner(MyID)
	if ( distance > 2 or distance == -1) then		-- ͤԵ˵	
		if(FLAG_Friend_Add_Answer_X == 0 and FLAG_Friend_Add_Answer_Y == 0) then
			MyState = FOLLOW_ST
			TraceAI ("IDLE_ST -> FOLLOW_ST")
			return;
		end
	end

end


function OnStandby_ST()
	local actors = GetActors()
	local owner = GetV(V_OWNER, MyID)
	local target

	for i,v in ipairs(actors) do
		target = GetV(V_TARGET, v)
		if(target == MyID or target == owner) then
			MyState = CHASE_ST
			MyEnemy = v
			TraceAI ("STANDBY_ST -> CHASE_ST : ENEMY ATTACKED OWNER OR ME")
			return 
		end
	end

	if( GetV(V_POSITION, owner) ~= GetV(V_POSITION, MyID)) then
		MyState = IDLE_ST
		TraceAI ("STANDBY_ST -> IDLE_ST")
	end
end


-------------------------------------------------------
-- ɽư˴ؤ
-------------------------------------------------------
function	OnFOLLOW_ST ()
	TraceAI ("OnFOLLOW_ST")
	local x, y
	
	if (GetDistanceFromOwner(MyID) <= 2) then							-- ͤȤεΥ3
		MyState = IDLE_ST												-- IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLW_ST")
		return;
	elseif (GetV(V_MOTION,MyID) == MOTION_STAND) then					-- ⡼Ωʤ
		-- TraceAI ("MOTION_STAND")										-- ǥХåå
		MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID));		-- Ū()
		Move (MyID,MyDestX, MyDestY)									-- ư
		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return;
	elseif (GetV(V_MOTION,MyID) == MOTION_MOVE) then					-- ⡼󤬰ưʤ
		x, y = GetV (V_POSITION,MyID)									-- ߤΰ֤
		if (math.abs(x-MyDestX)+math.abs(y-MyDestY) < 3) then			-- ŪϤΥʤ
			-- TraceAI ("MOTION_MOVE Move")								-- ǥХåå
			MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID));	-- Ū(ͤΰ)
			Move (MyID,MyDestX,MyDestY)									-- ư
			TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		else															-- ŪϤ󤱤ФΤޤ
			TraceAI ("MOTION_MOVE NoMove")
			TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		end
		return;
	end
end

-------------------------------------------------------
-- ŨåȤꥻåȤؿ
-------------------------------------------------------

function ResetEnemy()
	MyState = IDLE_ST
	MyEnemy = 0
	MyDestX, MyDestY = 0,0
end


-------------------------------------------------------
-- Ũ˴ؤ
-------------------------------------------------------
function	OnCHASE_ST ()	--ߥ򴹥

	TraceAI ("OnCHASE_ST")

	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if (true == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_INATTACKSIGHT_IN
		MyState = ATTACK_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyID);
		local ownerX, ownerY
		ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,MyID)) -- ͤΰ
		if (ownerX > MyDestX) then
			MyDestX = MyDestX + 1
		elseif (ownerX < MyDestX) then
			MyDestX = MyDestX - 1
		end
		if (ownerY > MyDestY) then
			MyDestY = MyDestY + 1
		elseif (ownerY < MyDestY) then
			MyDestY = MyDestY - 1
		end
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end
	local motion = GetV( V_MOTION, MyEnemy )
	if motion == MOTION_DEAD or motion == -1 then -- ˴⡼Ũפʤ by Privatemoon
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST")
		return
	end
	if not IsNotNoManner( MyID, MyEnemy ) then	-- ܶïåȤå줿Ȥ by Privatemoon
		ResetEnemy()
		TraceAI ("CHASE_ST -> IDLE_ST")
		return
	end
	local x, y = GetV (V_POSITION,MyEnemy)
	if (MyDestX ~= x or MyDestY ~= y) then			-- DESTCHANGED_IN
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end
	--if GetV(V_MOTION, MyID) ~= MOTION_MOVE then	-- åν by Privatemoon
	--	MyDestX, MyDestY = 0, 0
	--	MoveToOwner( MyID )	-- å뤫æ	
	--	TraceAI("CHASE_ST -> CHASE_ST : Detect Stuck (Reset)")
	--	return
	--end

end


-------------------------------------------
--  оݤߤξԥ󥹥Ǥ뤫ɤΤؿ by Privatemoon
-------------------------------------------
function	Check_BP (target)
	if (target == 1555 or target == 1570 or target == 1579 or target == 1589 or target == 1590) then
		return true
	else
		return false
	end
end


-------------------------------------------------------
-- ˴ؤ
-------------------------------------------------------
function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	if (true == IsOutOfSight(MyID,MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		Ludin_AttackCount        = 0
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("ATTACK_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	
	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then   -- ENEMY_DEAD_IN
		Ludin_AttackCount        = 0
		local cmd = List.popleft (ResCmdList)
		if (cmd ~= nil) then
			ProcessCommand (cmd)
		else
			MyState = IDLE_ST
		end
	end
		
	if (false == IsInAttackSight(MyID,MyEnemy)) then  -- ENEMY_OUTATTACKSIGHT_IN
			Ludin_AttackCount        = 0
		if(IsStealMyTarget(MyID,MyEnemy) == true) then
			MySkipEnemy = MyEnemy
			-- ʤܤ
			local object = GetMyEnemy (MyID)
			if(0 ~= object) then
				MyState = CHASE_ST
				MyEnemy = object
				TraceAI ("ATTACK_ST -> CHASE_ST : ATTACKED_IN (I FOUND NEW ENEMY)")
			else
				-- ʤʤмͤΤФ˰ư
				MoveToOwner (MyID)
				MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,MyID))
				MyState = IDLE_ST			
				MyEnemy = 0
				TraceAI ("ATTACK_ST -> IDLE_ST : I DON'T WANT STEAL")
			end
			return 
		end

		MyState = CHASE_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (MyID,MyDestX,MyDestY)
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	MySkipEnemy = 0

	-- 䤿˹⥹
	if(MySkill == 0) then
		Cast_SkillWhenFight(MyID)
		Cast_SkillWhenStartFight(MyID)
	end

	if (MySkill == 0) then
		Attack (MyID,MyEnemy)
          Ludin_AttackCount        = Ludin_AttackCount + 1
	else
		SkillObject (MyID,MySkillLevel,MySkill,MyEnemy)
		MySkill = 0
	end
	
       -- ## ʪɲäޤ.
        if ( GetV ( V_TARGET, MyEnemy ) == 0 ) then
        -- $$ ǲ 30ȤʤäƤ뤳ȤǸä֤Ǥ.
        -- $$ ®٤ˤäƹѤޤ. ϤǤ..
        -- $$ ͤ 10Ǽ 2~3沥äƸƥꥹȤˤޤ.
        -- $$ ͤ 20Ǽ 4~6沥äƸƥꥹȤˤޤ.
        	if ( Ludin_AttackCount >= 10 ) then
                Ludin_AttackCount        = 0

                Ludin_FP = io.open ( "./AI/UnAttackList.txt", "a+" )
                Ludin_FP:seek ( "end", 0 )
                Ludin_FP:write ( MyEnemy )
                Ludin_FP:write ( "\n" )
                Ludin_FP:close ( )

                Ludin_DontAttackList[Ludin_nDAL]= string.format( "%u", MyEnemy )
                Ludin_nDAL        = Ludin_nDAL + 1

                MyState        = FOLLOW_ST
                MyEnemy        = 0
                MySkill        = 0
                return
        	end
        end
        -- ## ޤ..

        TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
        return
end



function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		if(FLAG_Friend_Add_Answer_X ~= 0 and FLAG_Friend_Add_Answer_Y ~= 0) then
			OnMOVE_CMD(FLAG_Friend_Add_Answer_X, FLAG_Friend_Add_Answer_Y)
			FLAG_Friend_Add_Answer_X = 0
			FLAG_Friend_Add_Answer_Y = 0
		else
			local cmd = List.popleft (ResCmdList)
			if (cmd ~= nil) then
				ProcessCommand (cmd)						-- reserved command process
			else
				MyState = IDLE_ST
			end
		end
	end
end


function OnSTOP_CMD_ST ()


end




function OnATTACK_OBJECT_CMD_ST ()

end




function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then			
		object = GetFriendEnemy (MyID) 
	end
	if (object == 0) then			
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		local cmd = List.popleft (ResCmdList)
		if (cmd ~= nil) then
			ProcessCommand (cmd)
		else
			MyState = IDLE_ST
		end
	end

end




function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetFriendEnemy (MyID) 
	end
	if (object == 0) then							
		object = GetMyEnemy (MyID) 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,MyID)
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (MyID,MyDestX,MyDestY)
	end

end




function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance(MyEnemy,MyID)
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,MyID)) then
				Attack (MyID,MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end


	local	object = GetOwnerEnemy (MyID)
	if (object == 0) then							
		object = GetFriendEnemy (MyID)
		if (object == 0) then							
			object = GetMyEnemy (MyID)
			if (object == 0) then						
				return
			end
		end
	end

	MyEnemy = object

end




function OnSKILL_OBJECT_CMD_ST ()
	TraceAI ("OnSKILL_OBJECT_CMD_ST")
end


function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,MyID)
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,MyID,MySkill)) then	-- DESTARRIVED_IN
		SkillGround (MyID,MySkillLevel,MySkill,MyDestX,MyDestY)
		local cmd = List.popleft (ResCmdList)
		if (cmd ~= nil) then
			ProcessCommand (cmd)
		else
			MyState = IDLE_ST
			MySkill = 0
		end
	end

end



function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local ownerX, ownerY, myX, myY
	ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,MyID)) -- 
	myX, myY = GetV (V_POSITION,MyID)					  -- 
	
	local d = GetDistance (ownerX,ownerY,myX,myY)

	if ( d <= 3) then									  -- 3ʲεΥʤ
		return 
	end

	local motion = GetV (V_MOTION,MyID)
	if (motion == MOTION_MOVE) then                       -- ư
		d = GetDistance (ownerX, ownerY, MyDestX, MyDestY)
		if ( d > 2) then                                  -- Ūѹ?
			MoveToOwner (MyID)
			MyDestX = ownerX
			MyDestY = ownerY
			return
		end
	else                                                  -- ¾ư
		MoveToOwner (MyID)
		MyDestX = ownerX
		MyDestY = ownerY
		return
	end
	
end



-- 롼
function	On_IN_CUSTOM_MESSAGE_LOOP_ST ()

	local owner = GetV(V_OWNER,MyID)

	if(MyEnemy ~= 0) then
		Cast_SkillCastling(MyID)		
	end

	MoveToOwnerWhenTooFar(MyID)

	-- ͤ
	local motion = GetV (V_MOTION, GetV (V_TARGET,owner) )
	if(motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
		Cast_SkillCastling_Owner(MyID)
	end

	Cast_SkillHeal(MyID)
	Cast_EmergencyAvoid_HP(MyID)
	Cast_EmergencyAvoid(MyID)
	Cast_SkillVenediction(MyID)
	
	-- ư
	AutoFlee(MyID, MyEnemy)
end


-------------------------------------------
--  ͤŨؿ
-------------------------------------------
function	GetOwnerEnemy (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	local ownerTarget = GetV( V_TARGET, GetV( V_OWNER, myid ) )
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid and Check_BP(GetV(V_HOMUNTYPE,v))==false) then		-- IDͤǤۥǤʤǤʤȤby Privatemoon
			if FOLLOW_OWNER_TARGETTING and ownerTarget > 0 and v == ownerTarget then
				return v	-- ߤΥäƤŨޤactors¸ߤͥˤ
			end			
			target = GetV (V_TARGET,v)
			if (target == owner) then
				if (IsMonster(v) == 1) then
					enemys[index] = v
					index = index+1
				else
					local motion = GetV(V_MOTION,i)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end


function	GetFriendEnemy (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (IsFriend(target) == true) then
				if (IsMonster(v) == 1) then
					enemys[index] = v
					index = index+1
				else
					local motion = GetV(V_MOTION,i)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end


function	GetMyEnemy (myid)
	local result = 0

	local attackmode = GetHomunAttackMode(myid)

	if (isMoveCommand() == 1) then
		return result
	end

	if (isStopSearchEnemy() == 1) then
		return result
	end

	if (attackmode == 0) then
		result = GetMyEnemyA (myid)
	elseif (attackmode == 1) then
		result = GetMyEnemyB (myid)
	elseif (attackmode == 2) then
		result = GetMyEnemyC (myid)
	end

	-- ʤܤ
	if(result ~= 0) then
		Cast_SkillWhenStartFight(myid)
	end

	return result

--	local type = GetV (V_HOMUNTYPE,myid)
--	if (type == AMISTR or type == AMISTR_H) then
--		result = GetMyEnemyA (myid)
--	elseif (type == LIF or type == LIF_H or type == FILIR or type == FILIR_H or type == VANILMIRTH or type == VANILMIRTH_H) then
--		result = GetMyEnemyC (myid)
--	end
--	return result
end




-------------------------------------------
--  蹶 GetMyEnemy
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid and MOTION_DEAD ~= GetV(V_MOTION,v)) then
			target = GetV (V_TARGET,v)
			if (target == myid) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end


-------------------------------------------
--  ɻߴؿ
-------------------------------------------
function IsNotNoManner( myid, id )
	local target = GetV( V_TARGET, id )
	return target == 0 or ( target == myid or target == GetV( V_OWNER, myid ) )
end



-------------------------------------------
--  蹶 GetMyEnemy
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local type
       -- ## ΰԤɲäޤ.
        local        Ludin_i        = 1, Ludin_NotAtack

	for i,v in ipairs(actors) do
			-- ͤǤ⼫ȤǤʤ˴⡼ŨǤʤǤʤȤ
		if (v ~= owner and v ~= myid and MOTION_DEAD ~= GetV(V_MOTION,v) and Check_BP(GetV(V_HOMUNTYPE,v)) == false) then
			-- ǤϤʤŨϰŨǤ
			if ((1 == IsMonster(v))	and IsNotNoManner( myid, v ) and ( GetDistance2(owner, v) <= TARGETDISTANCE-2 ))then
			
       -- ## Ƥɲäޤ.
        Ludin_NotAttack        = 0
        for Ludin_i = 1, (Ludin_nDAL - 1), 1 do
                if ( string.format( "%u", v ) == Ludin_DontAttackList[Ludin_i] ) then
                        Ludin_NotAttack        = 1
                        break
                end
        end

        if ( Ludin_NotAttack == 0 ) then
        -- ## ޤɲä..
        
				enemys[index] = v
				index = index+1
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end



-------------------------------------------
--  ̵Ū蹶 GetMyEnemy
-------------------------------------------
function	GetMyEnemyC (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local type
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
--			if (1 == IsMonster(v))	then
				enemys[index] = v
				index = index+1
--			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end



------------------------------------------------------
--ΧưΥᥤ롼
------------------------------------------------------
function AI(myid)

	MyID = myid
	local msg	= GetMsg (myid)			-- command
	local rmsg	= GetResMsg (myid)		-- reserved command
       	
	-- ## ˤɲäޤ.
	--        local        Ludin_String
	--        local        Ludin_FP = io.open ( "./AI/UnAttackList.txt", "r" )

	        Ludin_nDAL        = 1
        -- 䤭ΤäƤ⥿åȤʤ󥹥Ϲоݤʱ˽
        -- Ver 0.11 2005.07.10 by [ǥ] <sara(kRO)>
      	--  if ( Ludin_FP == nil ) then
      	--          Ludin_FP = io.open ( "./AI/UnAttackList.txt", "w+" )
      	--  else
      	--         while true do
      	--                Ludin_String = Ludin_FP:read ( )
      	--               if ( Ludin_String == nil ) then
      	--                      break
      	--             end

      	--                  Ludin_DontAttackList[Ludin_nDAL] = Ludin_String
      	--                 Ludin_nDAL        = Ludin_nDAL + 1
      	--          end
	--        end

       	-- Ludin_FP:close ( )
        -- ## ޤɲäɤǤ.

	IN_InitAI()

	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg) -- ͽ̿¸
			end
		end
	else
		List.clear (ResCmdList)	-- ̿᤬Ϥ줿顢ͽ󤷤Ƥ̿.
		ProcessCommand (msg)	-- ̿
	end
     local Owner_target = GetV(V_TARGET,GetV (V_OWNER,MyID))
     if (IsMonster(Owner_target)==1 ) then 
                MyEnemy =Owner_target
                MyState=ATTACK_ST -- 
     end
	-- ֽ
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then					
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	elseif (MyState == STANDBY_ST) then
		OnStandby_ST()
	end

	On_IN_CUSTOM_MESSAGE_LOOP_ST ()
end

